// --------------------------------------------------------------------------
// All or portions of this software are copyrighted by Dothinkey.
// Copyright 1996-2008 Dothinkey Corporation.  
// Company proprietary.
// --------------------------------------------------------------------------
//******************************************************************************
/**
 *  \file           DSCAMAPI.h
 *  \brief          Defines the API for the CM300 DLL application
 *  \author         Mike 
 *  \version        \$ Revision: 0.1 \$         
 *  \arg            first implemetation    
 *  \date           2007/12/08 10:52:00     
 */
#ifndef _DSCAMAPI_H_
#define _DACAMAPI_H_
#include "stdafx.h"
#include "DSDefine.h"
// DECLDIR will perform an export for us


#ifdef DLL_EXPORT
	#define DT_API extern "C" __declspec(dllexport) 
#else
	#define DT_API extern "C" __declspec(dllimport) 
#endif

/*==============================================================
:	CameraInit
:  ʼƵ豸

:	uiResolution  
        hWndDisplay	  Ƶʾؼ
        lpThreadparam Ƶ̴ַ߳  
ֵ: óɹSTATUS_OK 򷵻ش
˵:   
  --------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraInit(DS_SNAP_PROC pCallbackFunction,IN DS_RESOLUTION uiResolution, IN HWND hWndDisplay, IN LPVOID lpThreadparam );
/*==============================================================
:	CameraUnInit
:	ʼ豸
:   
ֵ: óɹSTATUS_OK 򷵻ش
˵:   ڳ˳ʱ,ͷڴռ
  --------------------------------------------------------------*/

DT_API DS_CAMERA_STATUS CameraUnInit(void);
/*==============================================================
:	CameraPlay
:	Ƶ
: 
ֵ: óɹSTATUS_OK 򷵻ش  
˵:   
  --------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraPlay(void);

/*==============================================================
:	CameraPlay
:	ֹͣƵ
:   
ֵ: óɹSTATUS_OK 򷵻ش
˵:   
  --------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraStop(void);

/*==============================================================
:	CameraCaptureFile
:	ɼһ֡ͼļļʽFileType趨ı
:   strFileName  ļ(Ŀ¼·)
        FileType     ļ, FILE_TYPE 
ֵ: óɹSTATUS_OK 򷵻ش   
˵:   Ƶֹͣʱᱣһͼ.
  --------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraCaptureFile(IN LPCTSTR strFileName, IN BYTE FileType);
/*==============================================================
:	CameraSnap
:	ɼһ֡ͼڴ
:   *pBuffer ͼָ

  ֵ: óɹSTATUS_OK 򷵻ش   
  ˵:   ɼһ֡ͼݵڴ滺ͼݻСɲɼ
  ͼĳߴ,ͼĴСCameraGetImageSize()õ,μCameraGetImageSize()˵,
  С = ͼ * ͼ߶ * 3 + 512
  
--------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraSnap(BYTE *pBuffer, IN DS_DATA_TYPE DataType);
/*==============================================================
:	CameraSetResolution
:	ͼֱ
:   Resolution ͼֱ,DS_RESOLUTION
ֵ: óɹSTATUS_OK 򷵻ش
˵:   
--------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraSetResolution(IN DS_RESOLUTION Resolution);
/*==============================================================
:	CameraGetImageSize
:	ȡǰͼС
:   *pWidth ͼȵָ
		*pHeightͼ߶ȵָ
ֵ: óɹSTATUS_OK 򷵻ش
˵:   
--------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraGetImageSize(int *pWidth, int *pHeight);
/*==============================================================
:	CameraSetSnapMode
:	ͼɼģʽ
:   SnapMode ͼɼģʽ DS_SNAP_MODE
		
ֵ: óɹSTATUS_OK 򷵻ش
˵:   
--------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraSetSnapMode(IN DS_SNAP_MODE SnapMode);
/*==============================================================
:	CameraSetAeState
:	Զعģʽ
:   bState - TRUE Զع
               - FALSE ֶع
		
ֵ: óɹSTATUS_OK 򷵻ش
˵:   
--------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraSetAeState(IN BOOL bState);
/*==============================================================
:	CameraGetAeState
:	ȡԶعģʽ
:   *pAeState ״ָ̬
		
ֵ: óɹSTATUS_OK 򷵻ش
˵:   
--------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraGetAeState(BOOL *pAeState);
/*==============================================================
:	CameraSetAWBState
:   ðƽģʽ
:   bAWBState - TRUE Զƽ
                  - FALSE ֶƽ
		
ֵ: óɹSTATUS_OK 򷵻ش
˵:   
--------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraSetAWBState(BOOL bAWBState);
/*==============================================================
:	CameraGetAWBState
:   ȡƽģʽ
:   *pAWBState ״ָ̬
		
ֵ: óɹSTATUS_OK 򷵻ش
˵:   
--------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraGetAWBState(BOOL *pAWBState);
/*==============================================================
:	CameraSetAeTarget
:   趨ԶعĿֵ
:   uiAeTarget -ԶعĿֵ
		
ֵ: óɹSTATUS_OK 򷵻ش
˵:   
--------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraSetAeTarget(IN BYTE uiAeTarget);
/*==============================================================
:	CameraGetAeTarget
:   ȡԶعĿֵ
:   *pAeTarget -عĿֵָ
		
ֵ: óɹSTATUS_OK 򷵻ش
˵:   
--------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraGetAeTarget(IN OUT BYTE *pAeTarget);
/*==============================================================
:	CameraSetExposureTime
:   趨عʱ
:   uiExposureTime -عʱ
		
ֵ: óɹSTATUS_OK 򷵻ش
˵:   
--------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraSetExposureTime(IN int uiExposureTime);
/*==============================================================
:	CameraGetExposureTime
:   ȡعʱ
:   *pExposureTime -عʱָ
		
ֵ: óɹSTATUS_OK 򷵻ش
˵:   
--------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraGetExposureTime(IN int *pExposureTime);
/*==============================================================
:	CameraSetAnalogGain
:   趨
:   usAnalogGain 
		
ֵ: óɹSTATUS_OK 򷵻ش
˵:   
--------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraSetAnalogGain(IN USHORT usAnalogGain);
/*==============================================================
:	CameraGetAnalogGain
:   趨
:   *pAnalogGain ָ
		
ֵ: óɹSTATUS_OK 򷵻ش
˵:   
--------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraGetAnalogGain(IN USHORT *pAnalogGain);
/*==============================================================
:	CameraSetGain
:   趨ɫͨ
:   RGain ͨ
		GGain ͨ
		BGain ͨ
		
ֵ: óɹSTATUS_OK 򷵻ش
˵:   
--------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraSetGain(IN USHORT RGain, USHORT GGain, USHORT BGain);
/*==============================================================
:	CameraGetGain
:   ȡɫͨ
:   *pRGain źָͨ
		*pGGain ָͨ
		*pBGain ָͨ
		
ֵ: óɹSTATUS_OK 򷵻ش
˵:   
--------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraGetGain(IN int *pRGain, int *pGGain, int *pBGain);
/*==============================================================
:	CameraSetGamma
:   趨GAMMA
:   uiGamma 
		
ֵ: óɹSTATUS_OK 򷵻ش
˵:   
--------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraSetGamma(IN BYTE uiGamma);
/*==============================================================
:	CameraGetGamma
:   ȡGAMMA
:   *pGamma GAMMAָ
		
ֵ: óɹSTATUS_OK 򷵻ش
˵:   
--------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraGetGamma(IN BYTE *pGamma);
/*==============================================================
:	CameraSetColorEnhancement
:   ʹɫǿ
:   bEnable - TRUEʹ 
                - FALSE 
		
ֵ: óɹSTATUS_OK 򷵻ش
˵:   
--------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraSetColorEnhancement(IN BOOL bEnable);
/*==============================================================
:	CameraGetColorEnhancement
:   
:    
		
ֵ: óɹSTATUS_OK 򷵻ش
˵:   
--------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraGetColorEnhancement(IN BOOL *pEnable);
/*==============================================================
:	CameraSetSaturation
:   趨Ͷ
:   uiSaturation 
		
ֵ: óɹSTATUS_OK 򷵻ش
˵:   
--------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraSetSaturation(IN BYTE uiSaturation);
/*==============================================================
:	CameraGetSaturation
:   ȡͶ
:   *pSaturation űͶȵָ
		
ֵ: óɹSTATUS_OK 򷵻ش
˵:   
--------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraGetSaturation(IN BYTE *pSaturation);
/*==============================================================
:	CameraSetContrast
:   趨Աȶ
:   uiContrast 
		
ֵ: óɹSTATUS_OK 򷵻ش
˵:   
--------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraSetContrast(IN BYTE uiContrast);
/*==============================================================
:	CameraGetContrast
:   ȡԱȶ
:   *pContrast 
		
ֵ: óɹSTATUS_OK 򷵻ش
˵:   
--------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraGetContrast(IN BYTE *pContrast);
/*==============================================================
:	CameraSetMirror
:   趨ͼ
:   uiDir ָ,DS_MIRROR_DIRECTION
        bEnable - TRUE 
		        - FALSE ȡ
		
ֵ: óɹSTATUS_OK 򷵻ش
˵:   
--------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraSetMirror(IN DS_MIRROR_DIRECTION uiDir, IN BOOL bEnable);
/*==============================================================
:	CameraSetMonochrome
:   趨ɫ
:   bEnable - TRUE ɫ
                - FALSE ȡɫ
		
ֵ: óɹSTATUS_OK 򷵻ش
˵:   
--------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraSetMonochrome(IN BOOL bEnable);
/*==============================================================
:	CameraGetMonochrome
:   ȡɫ趨
:   *pEnable ״ָ̬
		
ֵ: óɹSTATUS_OK 򷵻ش
˵:   
--------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraGetMonochrome(IN BOOL *pEnable);
/*==============================================================
:	CameraSetFrameSpeed
:   趨֡
:   FrameSpeed ֡,嶨DS_FRAME_SPEED
		
ֵ: óɹSTATUS_OK 򷵻ش
˵:   
--------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraSetFrameSpeed(IN DS_FRAME_SPEED FrameSpeed);
/*==============================================================
:	CameraGetFrameSpeed
:   趨֡
:   FrameSpeed ֡,嶨DS_FRAME_SPEED
		
ֵ: óɹSTATUS_OK 򷵻ش
˵:   
--------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraGetFrameSpeed(IN BYTE *pFrameSpeed);

/*==============================================================
:	CameraSetTriggerPolarity
:   趨ⴥźŵļ
:   Polarity ,嶨DS_POLARITY
		
ֵ: óɹSTATUS_OK 򷵻ش
˵:   
--------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraSetTriggerPolarity(IN DS_POLARITY  Polarity);
/*==============================================================
:	CameraSetStrobePolarity
:   趨źŵļ
:    źŵļ 
		
ֵ: óɹSTATUS_OK 򷵻ش
˵:   
--------------------------------------------------------------*/
DT_API DS_CAMERA_STATUS CameraSetStrobePolarity(IN DS_POLARITY  Polarity);

DT_API DS_CAMERA_STATUS CameraSetDeadPixelOffset(IN BYTE uiOffset);
DT_API DS_CAMERA_STATUS CameraGetDeadPixelOffset(IN BYTE *pOffset);
DT_API DS_CAMERA_STATUS CameraEnableDeadPixelCorrection(void);

DT_API DS_CAMERA_STATUS CameraSetSubsampleMode(IN DS_SUBSAMPLE_MODE SubsampleMode);
DT_API DS_CAMERA_STATUS CameraGetSubsampleMode(IN BYTE *pSubsampleMode);

DT_API DS_CAMERA_STATUS CameraSetLightFrquency(IN DS_LIGHT_FREQUENCY LightFrequency );
DT_API DS_CAMERA_STATUS CameraGetLightFrquency(IN BYTE *pLightFrequency );

DT_API DS_CAMERA_STATUS CameraSaveParameter(IN DS_PARAMETER_TEAM Team);
DT_API DS_CAMERA_STATUS CameraReadParameter(IN DS_PARAMETER_TEAM Team);
DT_API DS_CAMERA_STATUS CameraGetCurrentParameterTeam(IN BYTE *pTeam);
#endif