// SetResolution.cpp : implementation file
//

#include "stdafx.h"
#include "dIcamdemo.h"
#include "SetResolution.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetResolution dialog

CSetResolution::CSetResolution(CWnd* pParent /*=NULL*/)
	: CDialog(CSetResolution::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSetResolution)
	m_RSLTIndex = 1;
	m_CaptureIndex = 1;
	m_HOff = 0;
	m_VOff = 0;
	m_Height = 0;
	m_Width = 0;
	m_pParentWnd = pParent;
	//}}AFX_DATA_INIT
}


void CSetResolution::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetResolution)
	DDX_Text(pDX, IDC_HOFF, m_HOff);
	DDX_Text(pDX, IDC_VOFF, m_VOff);
	DDX_Text(pDX, IDC_HEIGHT, m_Height);
	DDX_Text(pDX, IDC_WIDTH, m_Width);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetResolution, CDialog)
	//{{AFX_MSG_MAP(CSetResolution)
	ON_EN_CHANGE(IDC_HOFF, OnChangeHoff)
	ON_EN_CHANGE(IDC_VOFF, OnChangeVoff)
	ON_EN_CHANGE(IDC_WIDTH, OnChangeWidth)
	ON_EN_CHANGE(IDC_HEIGHT, OnChangeHeight)
	ON_BN_CLICKED(IDC_RESOLUTION_A, OnResolutionA)
	ON_BN_CLICKED(IDC_RESOLUTION_B, OnResolutionB)
	ON_BN_CLICKED(IDC_RESOLUTION_C, OnResolutionC)
	ON_BN_CLICKED(IDC_RESOLUTION_D, OnResolutionD)
	ON_BN_CLICKED(IDC_RESOLUTION_E, OnResolutionE)
	ON_BN_CLICKED(IDC_CAPTURERESOLUTION_A, OnCaptureresolutionA)
	ON_BN_CLICKED(IDC_CAPTURERESOLUTION_B, OnCaptureresolutionB)
	ON_BN_CLICKED(IDC_CAPTURERESOLUTION_C, OnCaptureresolutionC)
	ON_BN_CLICKED(IDC_CAPTURERESOLUTION_D, OnCaptureresolutionD)
	ON_BN_CLICKED(IDC_CAPTURERESOLUTION_E, OnCaptureresolutionE)
	ON_BN_CLICKED(IDC_RESOLUTION_F, OnResolutionF)
	ON_BN_CLICKED(IDC_CAPTURERESOLUTION_F, OnCaptureresolutionF)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetResolution message handlers



void CSetResolution::OnOK() 
{
	// TODO: Add extra validation here
	m_pParentWnd->PostMessage(WM_DEL_SETRESOLUTION_DLG, 0, 1);
	CDialog::OnOK();
}

void CSetResolution::OnCancel() 
{
	// TODO: Add extra cleanup here
	m_pParentWnd->PostMessage(WM_DEL_SETRESOLUTION_DLG,0,0);
	CDialog::OnCancel();
}

BOOL CSetResolution::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	//Preview
	GetDlgItem(IDC_HOFF)->EnableWindow(FALSE);
	GetDlgItem(IDC_VOFF)->EnableWindow(FALSE);
	GetDlgItem(IDC_WIDTH)->EnableWindow(FALSE);
	GetDlgItem(IDC_HEIGHT)->EnableWindow(FALSE);

	SetDlgItemText(IDC_RESOLUTION_A, RESOLUTION_A_TEXT);
	SetDlgItemText(IDC_RESOLUTION_B, RESOLUTION_B_TEXT);
	SetDlgItemText(IDC_RESOLUTION_C, RESOLUTION_C_TEXT);
	SetDlgItemText(IDC_RESOLUTION_D, RESOLUTION_D_TEXT);
	SetDlgItemText(IDC_RESOLUTION_E, RESOLUTION_E_TEXT);
	SetDlgItemText(IDC_RESOLUTION_F, RESOLUTION_F_TEXT);

	GetDlgItem(IDC_RESOLUTION_A)->EnableWindow(RESOLUTION_A_ENABLE);
	GetDlgItem(IDC_RESOLUTION_B)->EnableWindow(RESOLUTION_B_ENABLE);
	GetDlgItem(IDC_RESOLUTION_C)->EnableWindow(RESOLUTION_C_ENABLE);
	GetDlgItem(IDC_RESOLUTION_D)->EnableWindow(RESOLUTION_D_ENABLE);
	GetDlgItem(IDC_RESOLUTION_E)->EnableWindow(RESOLUTION_E_ENABLE);
	GetDlgItem(IDC_RESOLUTION_F)->EnableWindow(RESOLUTION_F_ENABLE);	
	switch(m_RSLTIndex)
	{
		case RESOLUTION_A_INDEX:
			CheckDlgButton(IDC_RESOLUTION_A, 1);
			break;
		case RESOLUTION_B_INDEX:
			CheckDlgButton(IDC_RESOLUTION_B, 1);
			break;
		case RESOLUTION_C_INDEX:
			CheckDlgButton(IDC_RESOLUTION_C, 1);
			break;
		case RESOLUTION_D_INDEX:
			CheckDlgButton(IDC_RESOLUTION_D, 1);
			break;	
		case RESOLUTION_E_INDEX:
			CheckDlgButton(IDC_RESOLUTION_E, 1);
			break;	
		case RESOLUTION_F_INDEX:
			CheckDlgButton(IDC_RESOLUTION_F, 1);
			GetDlgItem(IDC_HOFF)->EnableWindow(TRUE);
			GetDlgItem(IDC_VOFF)->EnableWindow(TRUE);
			GetDlgItem(IDC_WIDTH)->EnableWindow(TRUE);
			GetDlgItem(IDC_HEIGHT)->EnableWindow(TRUE);
			break;		
		default:
			break;
	}

	//Capture

	SetDlgItemText(IDC_CAPTURERESOLUTION_A, RESOLUTION_A_TEXT);
	SetDlgItemText(IDC_CAPTURERESOLUTION_B, RESOLUTION_B_TEXT);
	SetDlgItemText(IDC_CAPTURERESOLUTION_C, RESOLUTION_C_TEXT);
	SetDlgItemText(IDC_CAPTURERESOLUTION_D, RESOLUTION_D_TEXT);
	SetDlgItemText(IDC_CAPTURERESOLUTION_E, RESOLUTION_E_TEXT);
	SetDlgItemText(IDC_CAPTURERESOLUTION_F, RESOLUTION_F_TEXT);

	GetDlgItem(IDC_CAPTURERESOLUTION_A)->EnableWindow(RESOLUTION_A_ENABLE);
	GetDlgItem(IDC_CAPTURERESOLUTION_B)->EnableWindow(RESOLUTION_B_ENABLE);
	GetDlgItem(IDC_CAPTURERESOLUTION_C)->EnableWindow(RESOLUTION_C_ENABLE);
	GetDlgItem(IDC_CAPTURERESOLUTION_D)->EnableWindow(RESOLUTION_D_ENABLE);
	GetDlgItem(IDC_CAPTURERESOLUTION_E)->EnableWindow(RESOLUTION_E_ENABLE);
	GetDlgItem(IDC_CAPTURERESOLUTION_F)->EnableWindow(RESOLUTION_F_ENABLE);	
	
	switch(m_CaptureIndex)
	{
	case RESOLUTION_A_INDEX:
		CheckDlgButton(IDC_CAPTURERESOLUTION_A, 1);
		break;
	case RESOLUTION_B_INDEX:
		CheckDlgButton(IDC_CAPTURERESOLUTION_B, 1);
		break;
	case RESOLUTION_C_INDEX:
		CheckDlgButton(IDC_CAPTURERESOLUTION_C, 1);
		break;
	case RESOLUTION_D_INDEX:
		CheckDlgButton(IDC_CAPTURERESOLUTION_D, 1);
		break;	
	case RESOLUTION_E_INDEX:
		CheckDlgButton(IDC_CAPTURERESOLUTION_E, 1);
		break;	
	case RESOLUTION_F_INDEX:
		CheckDlgButton(IDC_CAPTURERESOLUTION_F, 1);
		break;
	default:
		break;
	}

	SetDisplayWindow();
	return TRUE;
	
	// return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CSetResolution::SetDisplayWindow()
{
	int x0 = 0;
	int y0 = 0;
	int nWinWidth =0;
	int nWinHeight=0;
	
	int iFullScrn_cx = GetSystemMetrics(SM_CXSCREEN);
	int iFullScrn_cy = GetSystemMetrics(SM_CYSCREEN);
	int iCAPTION     = GetSystemMetrics(SM_CYCAPTION);
	RECT temp;
	this->GetWindowRect(&temp);
	
	int Width = 0;
	int Height= 0;
	if (STATUS_OK != CameraGetImageSize(&Width, &Height))
	{
		Width = 640;
		Height= 480;	
	}
	if (Width < (iFullScrn_cx-48))
	{
		nWinWidth = Width+3;
		nWinHeight = Height+48;
		x0 = (iFullScrn_cx - Width)>>1;
		y0 = (iFullScrn_cy - Height)>>1;
	}
	else
	{
		x0 = 0;
		y0 = 0;
		nWinWidth = iFullScrn_cx;
		nWinHeight = iFullScrn_cy;
		Width = iFullScrn_cx-4;
		Height = iFullScrn_cy-36;
	}
	x0 = 0;
	y0 = 0;
	this->SetWindowPos(NULL, x0+150, y0+50,temp.right-temp.left, temp.bottom-temp.top,
		SWP_NOZORDER | SWP_SHOWWINDOW);
}

void CSetResolution::OnResolutionA() 
{
	// TODO: Add your control notification handler code here
	m_RSLTIndex = RESOLUTION_A_INDEX;
	GetDlgItem(IDC_HOFF)->EnableWindow(FALSE);
	GetDlgItem(IDC_VOFF)->EnableWindow(FALSE);
	GetDlgItem(IDC_WIDTH)->EnableWindow(FALSE);
	GetDlgItem(IDC_HEIGHT)->EnableWindow(FALSE);	
}

void CSetResolution::OnResolutionB() 
{
	// TODO: Add your control notification handler code here
	m_RSLTIndex = RESOLUTION_B_INDEX;
	GetDlgItem(IDC_HOFF)->EnableWindow(FALSE);
	GetDlgItem(IDC_VOFF)->EnableWindow(FALSE);
	GetDlgItem(IDC_WIDTH)->EnableWindow(FALSE);
	GetDlgItem(IDC_HEIGHT)->EnableWindow(FALSE);
}

void CSetResolution::OnResolutionC() 
{
	// TODO: Add your control notification handler code here
	m_RSLTIndex = RESOLUTION_C_INDEX;
	GetDlgItem(IDC_HOFF)->EnableWindow(FALSE);
	GetDlgItem(IDC_VOFF)->EnableWindow(FALSE);
	GetDlgItem(IDC_WIDTH)->EnableWindow(FALSE);
	GetDlgItem(IDC_HEIGHT)->EnableWindow(FALSE);
}

void CSetResolution::OnResolutionD() 
{
	// TODO: Add your control notification handler code here
	m_RSLTIndex = RESOLUTION_D_INDEX;
	GetDlgItem(IDC_HOFF)->EnableWindow(FALSE);
	GetDlgItem(IDC_VOFF)->EnableWindow(FALSE);
	GetDlgItem(IDC_WIDTH)->EnableWindow(FALSE);
	GetDlgItem(IDC_HEIGHT)->EnableWindow(FALSE);
}

void CSetResolution::OnResolutionE() 
{
	// TODO: Add your control notification handler code here
	m_RSLTIndex = RESOLUTION_E_INDEX;
	GetDlgItem(IDC_HOFF)->EnableWindow(FALSE);
	GetDlgItem(IDC_VOFF)->EnableWindow(FALSE);
	GetDlgItem(IDC_WIDTH)->EnableWindow(FALSE);
	GetDlgItem(IDC_HEIGHT)->EnableWindow(FALSE);
}

void CSetResolution::OnResolutionF() 
{
	// TODO: Add your control notification handler code here
	m_RSLTIndex = RESOLUTION_F_INDEX ;
	GetDlgItem(IDC_HOFF)->EnableWindow(TRUE);
	GetDlgItem(IDC_VOFF)->EnableWindow(TRUE);
	GetDlgItem(IDC_HEIGHT)->EnableWindow(TRUE);
	GetDlgItem(IDC_WIDTH)->EnableWindow(TRUE);
}

void CSetResolution::OnChangeHoff() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CSetResolution::OnChangeVoff() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CSetResolution::OnChangeWidth() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CSetResolution::OnChangeHeight() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CSetResolution::OnCaptureresolutionA() 
{
	// TODO: Add your control notification handler code here
	m_CaptureIndex = RESOLUTION_A_INDEX;

}

void CSetResolution::OnCaptureresolutionB() 
{
	// TODO: Add your control notification handler code here
	m_CaptureIndex = RESOLUTION_B_INDEX;

}

void CSetResolution::OnCaptureresolutionC() 
{
	// TODO: Add your control notification handler code here
	m_CaptureIndex = RESOLUTION_C_INDEX;

}

void CSetResolution::OnCaptureresolutionD() 
{
	// TODO: Add your control notification handler code here
	m_CaptureIndex = RESOLUTION_D_INDEX;

}

void CSetResolution::OnCaptureresolutionE() 
{
	// TODO: Add your control notification handler code here
	m_CaptureIndex = RESOLUTION_E_INDEX ;

}

void CSetResolution::OnCaptureresolutionF() 
{
	// TODO: Add your control notification handler code here
	m_CaptureIndex = RESOLUTION_F_INDEX ;
}
