// Setup.cpp : implementation file
//

#include "stdafx.h"
#include "DICAMDEMO.h"
#include "Setup.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetup dialog


CSetup::CSetup(CWnd* pParent /*=NULL*/)
	: CDialog(CSetup::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSetup)
	m_Aeen = FALSE;
	m_AeTarget = 0;
	m_BGain = 0;
	m_bColorCorrect = FALSE;
	m_Contrast = 0;
	m_ExpTime = 0;
	m_AnalogGain = 0;
	m_Gamma = 0;
	m_GGain = 0;
	m_RGain = 0;
	m_Saturation = 0;
	m_FrameSpeed = -1;
	m_bMono = FALSE;
	m_bHFlip = FALSE;
	m_bVFlip = FALSE;
	m_CheckBMP = FALSE;
	m_CheckJPG = FALSE;
	m_CheckRAW = FALSE;
	m_CheckPNG = FALSE;
	//}}AFX_DATA_INIT
	m_pParent = pParent;
	m_FTypeIndex = 0;
}


void CSetup::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetup)
	DDX_Control(pDX, IDC_SATURATION, m_SaturationCtrl);
	DDX_Control(pDX, IDC_RGAIN, m_RGainCtrl);
	DDX_Control(pDX, IDC_GGAIN, m_GGainCtrl);
	DDX_Control(pDX, IDC_GAMMA, m_GammaCtrl);
	DDX_Control(pDX, IDC_GAIN, m_AnalogGainCtrl);
	DDX_Control(pDX, IDC_EXPTIME, m_ExpTimeCtrl);
	DDX_Control(pDX, IDC_CONTRAST, m_ContrastCtrl);
	DDX_Control(pDX, IDC_BGAIN, m_BGainCtrl);
	DDX_Control(pDX, IDC_AETARGET, m_AeTargetCtrl);
	DDX_Check(pDX, IDC_AEEN, m_Aeen);
	DDX_Slider(pDX, IDC_AETARGET, m_AeTarget);
	DDX_Slider(pDX, IDC_BGAIN, m_BGain);
	DDX_Check(pDX, IDC_COLORCORRECT, m_bColorCorrect);
	DDX_Slider(pDX, IDC_CONTRAST, m_Contrast);
	DDX_Slider(pDX, IDC_EXPTIME, m_ExpTime);
	DDX_Slider(pDX, IDC_GAIN, m_AnalogGain);
	DDX_Slider(pDX, IDC_GAMMA, m_Gamma);
	DDX_Slider(pDX, IDC_GGAIN, m_GGain);
	DDX_Slider(pDX, IDC_RGAIN, m_RGain);
	DDX_Slider(pDX, IDC_SATURATION, m_Saturation);
	DDX_Radio(pDX, IDC_LOWSPEED, m_FrameSpeed);
	DDX_Check(pDX, IDC_MONO, m_bMono);
	DDX_Check(pDX, IDC_HFIP, m_bHFlip);
	DDX_Check(pDX, IDC_VFLIP, m_bVFlip);
	DDX_Check(pDX, IDC_CHECKBMP, m_CheckBMP);
	DDX_Check(pDX, IDC_CHECKJPG, m_CheckJPG);
	DDX_Check(pDX, IDC_CHECKRAW, m_CheckRAW);
	DDX_Check(pDX, IDC_CHECKPNG, m_CheckPNG);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSetup, CDialog)
	//{{AFX_MSG_MAP(CSetup)
	ON_BN_CLICKED(IDC_AWBONE, OnAwbone)
	ON_WM_CLOSE()
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_AETARGET, OnCustomdrawAetarget)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_BGAIN, OnCustomdrawBgain)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_CONTRAST, OnCustomdrawContrast)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_EXPTIME, OnCustomdrawExptime)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_GAIN, OnCustomdrawGain)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_GAMMA, OnCustomdrawGamma)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_GGAIN, OnCustomdrawGgain)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_RGAIN, OnCustomdrawRgain)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SATURATION, OnCustomdrawSaturation)
	ON_BN_CLICKED(IDC_COLORCORRECT, OnColorcorrect)
	ON_BN_CLICKED(IDC_AEEN, OnAeen)
	ON_BN_CLICKED(IDC_LOWSPEED, OnLowspeed)
	ON_BN_CLICKED(IDC_HIGHSPEED, OnHighspeed)
	ON_BN_CLICKED(IDC_LF_50HZ, OnLf50hz)
	ON_BN_CLICKED(IDC_LF_60HZ, OnLf60hz)
	ON_BN_CLICKED(IDC_PTA, OnPta)
	ON_BN_CLICKED(IDC_PTB, OnPtb)
	ON_BN_CLICKED(IDC_PTC, OnPtc)
	ON_BN_CLICKED(IDC_PTD, OnPtd)
	ON_BN_CLICKED(IDC_SAVE_PARAMETER, OnSaveParameter)
	ON_BN_CLICKED(IDC_HFIP, OnHfip)
	ON_BN_CLICKED(IDC_VFLIP, OnVflip)
	ON_BN_CLICKED(IDC_MONO, OnMono)
	ON_BN_CLICKED(IDC_CHECKJPG, OnCheckJPG)
	ON_BN_CLICKED(IDC_CHECKBMP, OnCheckBMP)
	ON_BN_CLICKED(IDC_CHECKRAW, OnCheckRAW)
	ON_BN_CLICKED(IDC_B2RGB_A, OnB2rgbA)
	ON_BN_CLICKED(IDC_B2RGB_B, OnB2rgbB)
	ON_BN_CLICKED(IDC_B2RGB_C, OnB2rgbC)
	ON_BN_CLICKED(IDC_LOAD_PARAMETER, OnLoadParameter)
	ON_BN_CLICKED(IDC_SUPERSPEED, OnSuperspeed)
	ON_BN_CLICKED(IDC_CHECKPNG, OnCheckpng)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetup message handlers
void CSetup::UpdateSetupWindow()
{
	INT RGain =64;
	INT GGain =64;
	INT BGain =64;
	BYTE uiTemp;
	BOOL bTemp;
	CString sTemp;
	BYTE Saturation = 128;
	BYTE Contrast = 0;
	USHORT usAnalogGain = 0;
	BYTE uiNoisePiexlOffset = 50;
	if (1) 
	{
		INT iTemp;
		CameraGetExposureTime(&iTemp);
		m_ExpTime = iTemp;
		CameraGetAeState(&bTemp);
		m_Aeen = bTemp;
		CameraGetAeTarget(&uiTemp);
		m_AeTarget =  uiTemp;
		CameraGetColorEnhancement(&bTemp);
		m_bColorCorrect = bTemp;

		CameraGetGamma(&uiTemp);
		m_Gamma = uiTemp;
		CameraGetAWBState(&bTemp);

		CameraGetMonochrome(&bTemp);
		m_bMono = bTemp;
		CameraGetMirror(MIRROR_DIRECTION_HORIZONTAL, &bTemp);
		m_bHFlip = bTemp;
		CameraGetMirror(MIRROR_DIRECTION_VERTICAL, &bTemp);
		m_bVFlip = bTemp;

		CameraGetAnalogGain( &usAnalogGain );

		CameraGetGain(&RGain, &GGain, &BGain),
		CameraGetSaturation(&Saturation);
		CameraGetContrast(&Contrast);

		UpdateData(FALSE);

		CameraGetFrameSpeed(&uiTemp);
		switch(uiTemp)
		{
			case FRAME_SPEED_NORMAL:
				CheckDlgButton(IDC_LOWSPEED, 1);
				CheckDlgButton(IDC_HIGHSPEED, 0);
				CheckDlgButton(IDC_SUPERSPEED, 0);
				break;
			case FRAME_SPEED_HIGH:
				CheckDlgButton(IDC_LOWSPEED, 0);
				CheckDlgButton(IDC_HIGHSPEED, 1);
				CheckDlgButton(IDC_SUPERSPEED, 0);
				break;
#ifdef HAVE_SPEED_SUPER
 			case FRAME_SPEED_SUPER:
 				CheckDlgButton(IDC_LOWSPEED, 0);
 				CheckDlgButton(IDC_HIGHSPEED, 0);
				CheckDlgButton(IDC_SUPERSPEED, 1);
				break;
#endif
			default:
				CheckDlgButton(IDC_LOWSPEED, 1);
				CheckDlgButton(IDC_HIGHSPEED, 0);
				CheckDlgButton(IDC_SUPERSPEED, 0);
				break;
		}

		CameraGetLightFrquency(&uiTemp);
		if (uiTemp)
		{
			CheckDlgButton(IDC_LF_60HZ, 1);
			CheckDlgButton(IDC_LF_50HZ, 0);
		}
		else
		{
			CheckDlgButton(IDC_LF_60HZ, 0);
			CheckDlgButton(IDC_LF_50HZ, 1);
		}
		CameraGetB2RGBMode(&uiTemp);
		switch (uiTemp)
		{
			case B2RGB_MODE_LAROCHE:
				CheckDlgButton(IDC_B2RGB_A, 1);	
				break;
			case B2RGB_MODE_HAMILTON:
				CheckDlgButton(IDC_B2RGB_B, 1);	
				break;
			case B2RGB_MODE_LINE:
				CheckDlgButton(IDC_B2RGB_C, 1);	
				break;
			default:
				break;
		}
	}
	m_AeTargetCtrl.SetPos(m_AeTarget);
	m_SaturationCtrl.SetPos(Saturation);
	m_ContrastCtrl.SetPos(Contrast);
	
	m_RGainCtrl.SetPos((int)(RGain));
	m_GGainCtrl.SetPos((int)(GGain));
	m_BGainCtrl.SetPos((int)(BGain));
	m_AnalogGainCtrl.SetPos(usAnalogGain);
	
	GetDlgItem(IDC_GAIN)->EnableWindow(!m_Aeen);
	GetDlgItem(IDC_STATIC_GAIN)->EnableWindow(!m_Aeen);

	GetDlgItem(IDC_EXPTIME)->EnableWindow(!m_Aeen);
	GetDlgItem(IDC_STATIC_TIME)->EnableWindow(!m_Aeen);

	GetDlgItem(IDC_AETARGET)->EnableWindow(m_Aeen);
	GetDlgItem(IDC_STATIC_TARGET)->EnableWindow(m_Aeen);

	GetDlgItem(IDC_SATURATION)->EnableWindow(m_bColorCorrect);

#ifndef HAVE_SPEED_SUPER
	GetDlgItem(IDC_SUPERSPEED)->EnableWindow(FALSE);
#endif
	UpdateData(TRUE);

	sTemp.Format("%d", m_AeTarget);
	GetDlgItem(IDC_AETARGETTEXT)->SetWindowText(sTemp);	


	sTemp.Format("%5.2f",GGain/64.0f);
	GetDlgItem(IDC_GTEXT)->SetWindowText(sTemp);

	sTemp.Format("%5.2f",RGain/64.0f);
	GetDlgItem(IDC_RTEXT)->SetWindowText(sTemp);

	sTemp.Format("%5.2f",BGain/64.0f);
	GetDlgItem(IDC_BTEXT)->SetWindowText(sTemp);
	
	sTemp.Format("%d",Saturation);
	GetDlgItem(IDC_SATURATIONTEXT)->SetWindowText(sTemp);
	
	sTemp.Format("%d",Contrast);
	GetDlgItem(IDC_CONTRASTTEXT)->SetWindowText(sTemp);
	
	UpdateExposurteTimeText();

	sTemp.Format("%d",m_AnalogGain);
	GetDlgItem(IDC_GAINTEXT)->SetWindowText(sTemp);

	sTemp.Format("%4.2f",m_Gamma/100.0f);
	GetDlgItem(IDC_GAMMATEXT)->SetWindowText(sTemp);

	UpdateData(FALSE);	
}

BOOL CSetup::OnInitDialog() 
{
	CDialog::OnInitDialog();
	USHORT uiMaxExpTime = 1000;
	CameraGetMaxExposureTime(&uiMaxExpTime);
	// TODO: Add extra initialization here
	m_GammaCtrl.SetRange(20, 150); //.20~1.5
	m_ContrastCtrl.SetRange(0, 255);
	m_SaturationCtrl.SetRange(0, 255);
	m_AeTargetCtrl.SetRange(40, 200);
	
	m_ExpTimeCtrl.SetRange(1, uiMaxExpTime); ////عʱ䷶Χ
	
	m_RGainCtrl.SetRange(20, 200);
	m_GGainCtrl.SetRange(20, 200);
	m_BGainCtrl.SetRange(20, 200);
	m_AnalogGainCtrl.SetRange(1, 48);

	UpdateData(TRUE);
	BYTE uiTemp;
	CameraGetCurrentParameterTeam(&uiTemp);
	switch (uiTemp)
	{
		case PARAMETER_TEAM_A:
			CheckDlgButton(IDC_PTA, 1);
			break;
		case PARAMETER_TEAM_B:
			CheckDlgButton(IDC_PTB, 1);
			break;
		case PARAMETER_TEAM_C:
			CheckDlgButton(IDC_PTC, 1);
			break;
		case PARAMETER_TEAM_D:
			CheckDlgButton(IDC_PTD, 1);
			break;
		default:
			uiTemp = PARAMETER_TEAM_A;
			CheckDlgButton(IDC_PTA, 1);
			break;
	}
	
	m_CheckJPG = m_FTypeIndex&FILE_JPG;
 	m_CheckBMP = (m_FTypeIndex&FILE_BMP)>>1;
 	m_CheckRAW = (m_FTypeIndex&FILE_RAW)>>2;
	m_CheckPNG = (m_FTypeIndex&FILE_PNG)>>3;


	UpdateData(FALSE);	
		
	m_ParameterTeam = (DI_PARAMETER_TEAM)uiTemp;

	UpdateSetupWindow();
	SetDisplayWindow();

	return TRUE;
}

void CSetup::OnOK() 
{
	// TODO: Add extra validation here
	m_pParent->PostMessage(WM_DEL_SETUP_DLG,(WPARAM)this);
	CDialog::OnOK();
}

void CSetup::OnAwbone() 
{
	// TODO: Add your control notification handler code here
	CameraSetAWBState(1);
	int RGain,GGain,BGain;

	CameraGetGain(&RGain, &GGain, &BGain);
	
	CString sTemp;
	sTemp.Format("%5.2f", GGain/64.0f);
	GetDlgItem(IDC_GTEXT)->SetWindowText(sTemp);

	sTemp.Format("%5.2f", RGain/64.0f);
	GetDlgItem(IDC_RTEXT)->SetWindowText(sTemp);

	sTemp.Format("%5.2f", BGain/64.0f);
	GetDlgItem(IDC_BTEXT)->SetWindowText(sTemp);
	
	m_RGainCtrl.SetPos((int)(RGain));
	m_GGainCtrl.SetPos((int)(GGain));
	m_BGainCtrl.SetPos((int)(BGain));
}

void CSetup::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	m_pParent->PostMessage(WM_DEL_SETUP_DLG, (WPARAM)this);		
	CDialog::OnClose();
}

void CSetup::OnCustomdrawAetarget(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	int pos;
	pos = m_AeTargetCtrl.GetPos();

	CameraSetAeTarget(pos);

	CString sTemp;
	sTemp.Format("%d",pos);
	GetDlgItem(IDC_AETARGETTEXT)->SetWindowText(sTemp);	
	UpdateData(TRUE);
	*pResult = 0;
}

void CSetup::OnCustomdrawContrast(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	int ContrastValue = m_ContrastCtrl.GetPos();
	
	CameraSetContrast(ContrastValue);
	CString sTemp;
	sTemp.Format("%d",ContrastValue);
	GetDlgItem(IDC_CONTRASTTEXT)->SetWindowText(sTemp);

	*pResult = 0;
}

void CSetup::OnCustomdrawExptime(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	if(m_Aeen)
	{
		return;
	}
	int pos;
	pos = m_ExpTimeCtrl.GetPos();

	CameraSetExposureTime(pos);	

	UpdateExposurteTimeText();
	UpdateData(TRUE);
	*pResult = 0;
}

void CSetup::OnCustomdrawGain(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	int AnalogGain = m_AnalogGainCtrl.GetPos();

	CameraSetAnalogGain(AnalogGain);
	CString sTemp;
	sTemp.Format("%d",AnalogGain);
	GetDlgItem(IDC_GAINTEXT)->SetWindowText(sTemp);
	*pResult = 0;
}

void CSetup::OnCustomdrawGamma(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	int GammaValue = m_Gamma;
	{
		CameraSetGamma(GammaValue);
		float x = GammaValue/100.0f;
		CString sTemp;
		sTemp.Format("%4.2f",x);
		GetDlgItem(IDC_GAMMATEXT)->SetWindowText(sTemp);
	}
	*pResult = 0;
}

void CSetup::OnCustomdrawBgain(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	UpdateColorGain();
	*pResult = 0;
}

void CSetup::OnCustomdrawGgain(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	UpdateColorGain();
	*pResult = 0;
}

void CSetup::OnCustomdrawRgain(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	UpdateColorGain();
	*pResult = 0;
}

void CSetup::OnCustomdrawSaturation(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	int SaturationValue = m_SaturationCtrl.GetPos();
	{
		//m_pCommUsb->SetSaturation(SaturationValue);
		CameraSetSaturation(SaturationValue);
		CString sTemp;
		sTemp.Format("%d",SaturationValue);
		GetDlgItem(IDC_SATURATIONTEXT)->SetWindowText(sTemp);
	}
	*pResult = 0;
}

void CSetup::OnColorcorrect() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CameraSetColorEnhancement(m_bColorCorrect);
	GetDlgItem(IDC_SATURATION)->EnableWindow(m_bColorCorrect);
}

void CSetup::OnAeen() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CameraSetAeState(m_Aeen);

	GetDlgItem(IDC_GAIN)->EnableWindow(!m_Aeen);
	GetDlgItem(IDC_STATIC_GAIN)->EnableWindow(!m_Aeen);
	
	GetDlgItem(IDC_EXPTIME)->EnableWindow(!m_Aeen);
	GetDlgItem(IDC_STATIC_TIME)->EnableWindow(!m_Aeen);
	
	GetDlgItem(IDC_AETARGET)->EnableWindow(m_Aeen);
	GetDlgItem(IDC_STATIC_TARGET)->EnableWindow(m_Aeen);
	if (!m_Aeen)
	{
		CString sTemp;
		INT iTemp;
		CameraGetExposureTime(&iTemp);
		m_ExpTime = iTemp;
		UpdateExposurteTimeText();

		m_ExpTimeCtrl.SetPos((int)(m_ExpTime));
		USHORT uiAnalogGain;
		CameraGetAnalogGain( &uiAnalogGain );
		m_AnalogGain = uiAnalogGain;
		m_AnalogGainCtrl.SetPos(m_AnalogGain);
		sTemp.Format("%d",m_AnalogGain);
		GetDlgItem(IDC_GAINTEXT)->SetWindowText(sTemp);	
	}	
}

void CSetup::UpdateColorGain()
{
	USHORT RGain = m_RGainCtrl.GetPos();
	USHORT GGain = m_GGainCtrl.GetPos();
	USHORT BGain = m_BGainCtrl.GetPos();
	
	CString sTemp;
	sTemp.Format("%5.2f", GGain/64.0f);
	GetDlgItem(IDC_GTEXT)->SetWindowText(sTemp);

	sTemp.Format("%5.2f", RGain/64.0f);
	GetDlgItem(IDC_RTEXT)->SetWindowText(sTemp);

	sTemp.Format("%5.2f", BGain/64.0f);
	GetDlgItem(IDC_BTEXT)->SetWindowText(sTemp);
	
	CameraSetGain(RGain, GGain, BGain);
}

void CSetup::OnLowspeed() 
{
	// TODO: Add your control notification handler code here
	CameraSetFrameSpeed(FRAME_SPEED_NORMAL);
	UpdateSetupWindow();
}

void CSetup::OnHighspeed() 
{
	// TODO: Add your control notification handler code here
	CameraSetFrameSpeed(FRAME_SPEED_HIGH);
	UpdateSetupWindow();
}

void CSetup::OnLf50hz() 
{
	// TODO: Add your control notification handler code here
	CameraSetLightFrquency(LIGHT_FREQUENCY_50HZ);	
}

void CSetup::OnLf60hz() 
{
	// TODO: Add your control notification handler code here
	CameraSetLightFrquency(LIGHT_FREQUENCY_60HZ);	
}

void CSetup::OnPta() 
{
	// TODO: Add your control notification handler code here
	m_ParameterTeam = PARAMETER_TEAM_A;
	CameraReadParameter(m_ParameterTeam);
	UpdateSetupWindow();
}

void CSetup::OnPtb() 
{
	// TODO: Add your control notification handler code here
	m_ParameterTeam = PARAMETER_TEAM_B;
	CameraReadParameter(m_ParameterTeam);
	UpdateSetupWindow();
}

void CSetup::OnPtc() 
{
	// TODO: Add your control notification handler code here
	m_ParameterTeam = PARAMETER_TEAM_C;
	CameraReadParameter(m_ParameterTeam);
	UpdateSetupWindow();
}

void CSetup::OnPtd() 
{
	// TODO: Add your control notification handler code here
	m_ParameterTeam = PARAMETER_TEAM_D;
	CameraReadParameter(m_ParameterTeam);
	UpdateSetupWindow();
}

void CSetup::OnSaveParameter() 
{
	// TODO: Add your control notification handler code here
	m_pParent->PostMessage(WM_DEL_SETUP_DLG,(WPARAM)this,1);
	CameraSaveParameter(m_ParameterTeam);
	UpdateSetupWindow();
}

void CSetup::SetDisplayWindow()
{
	int x0 = 0;
	int y0 = 0;
	int nWinWidth =0;
	int nWinHeight=0;
	
	int iFullScrn_cx = GetSystemMetrics(SM_CXSCREEN);
	int iFullScrn_cy = GetSystemMetrics(SM_CYSCREEN);
	int iCAPTION     = GetSystemMetrics(SM_CYCAPTION);
	RECT temp;
	this->GetWindowRect(&temp);
	
	int Width = 0;
	int Height= 0;
	if (STATUS_OK != CameraGetImageSize(&Width, &Height))
	{
		Width = 640;
		Height= 480;	
	}
	if (Width < (iFullScrn_cx-48))
	{
		nWinWidth = Width+3;
		nWinHeight = Height+48;
		x0 = (iFullScrn_cx - Width)>>1;
		y0 = (iFullScrn_cy - Height)>>1;
	}
	else
	{
		x0 = 0;
		y0 = 0;
		nWinWidth = iFullScrn_cx;
		nWinHeight = iFullScrn_cy;
		Width = iFullScrn_cx-4;
		Height = iFullScrn_cy-36;
	}
	x0 = max(0, x0);
	y0 = max(0, y0);
	this->SetWindowPos(NULL, x0+nWinWidth-temp.right+temp.left, y0+24,temp.right-temp.left, temp.bottom-temp.top,
		SWP_NOZORDER | SWP_SHOWWINDOW);
}

void CSetup::UpdateExposurteTimeText()
{
	UINT RawTime;
	CString sTemp;

	CameraGetRowTime(&RawTime);
	sTemp.Format("%.3f ms",(float)m_ExpTime*RawTime/1000);//
//	sTemp.Format("%d",m_ExpTime);//
	GetDlgItem(IDC_EXPTEXT)->SetWindowText(sTemp);
}

void CSetup::OnHfip() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CameraSetMirror(MIRROR_DIRECTION_HORIZONTAL, m_bHFlip);
}

void CSetup::OnVflip() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CameraSetMirror(MIRROR_DIRECTION_VERTICAL, m_bVFlip);
}

void CSetup::OnMono() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CameraSetMonochrome(m_bMono);
}

void CSetup::OnCheckJPG() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (m_CheckJPG == TRUE)
	{
		m_FTypeIndex |= FILE_JPG;
	}
	else
	{
		m_FTypeIndex &= ~FILE_JPG;
	}
}

void CSetup::OnCheckBMP() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (m_CheckBMP == TRUE)
	{
		m_FTypeIndex |= FILE_BMP;
	}
	else
	{
		m_FTypeIndex &= ~FILE_BMP;
	}
}

void CSetup::OnCheckpng() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (m_CheckPNG == TRUE)
	{
		m_FTypeIndex |= FILE_PNG;
	}
	else
	{
		m_FTypeIndex &= ~FILE_PNG;
	}	
}

void CSetup::OnCheckRAW() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (m_CheckRAW == TRUE)
	{
		m_FTypeIndex |= FILE_RAW;
	}
	else
	{
		m_FTypeIndex &= ~FILE_RAW;
	}
}

void CSetup::OnB2rgbA() 
{
	// TODO: Add your control notification handler code here
	CameraSetB2RGBMode(B2RGB_MODE_LAROCHE);
}

void CSetup::OnB2rgbB() 
{
	// TODO: Add your control notification handler code here
	CameraSetB2RGBMode(B2RGB_MODE_HAMILTON);
}

void CSetup::OnB2rgbC() 
{
	// TODO: Add your control notification handler code here
	CameraSetB2RGBMode(B2RGB_MODE_LINE);
}


void CSetup::OnLoadParameter() 
{
	// TODO: Add your control notification handler code here
	CameraLoadDefault();
	UpdateSetupWindow();
}

void CSetup::OnSuperspeed() 
{
	// TODO: Add your control notification handler code here
#ifdef HAVE_SPEED_SUPER
	CameraSetFrameSpeed(FRAME_SPEED_SUPER);
#endif
	UpdateSetupWindow();
}

